﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.Optimization;
using HeuristicLab.Optimizer;

namespace HeuristicLab.VariableInteractionNetworks
{
    internal class CreateTargetVariationExperiment : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider
    {
        public override string Name
        {
            get { return "Create Target Variation &Experiment"; }
        }
        public override IEnumerable<string> Structure
        {
            get { return new string[] { "&Edit" }; }
        }
        public override int Position
        {
            get { return 2300; }
        }
        public override string ToolTipText
        {
            get { return "Create an experiment for varying the target variable"; }
        }

        protected override void OnToolStripItemSet(EventArgs e)
        {
            ToolStripItem.Enabled = false;
        }
        protected override void OnActiveViewChanged(object sender, EventArgs e)
        {
            IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
            ToolStripItem.Enabled = (activeView != null) && (activeView.Content != null) && (activeView.Content is IOptimizer) && !activeView.Locked;
        }

        public override void Execute()
        {
            IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
            if ((activeView != null) && (activeView.Content != null) && (activeView.Content is IOptimizer) && !activeView.Locked)
            {
                using (CreateTargetVariationExperimentDialog dialog = new CreateTargetVariationExperimentDialog((IAlgorithm)activeView.Content))
                {
                    if (dialog.ShowDialog() == DialogResult.OK) MainFormManager.MainForm.ShowContent(dialog.Experiment);
                }
            }
        }
    }
}